// NEEDED

import java.util.Random;

/**
 * Class AIPlayer
 * Artifical intelligence for computer owned snakes.
 */
public class AIPlayer extends Controller{

	public FieldCell[][] field;

	/**
	 * Class constructor
	 */
	public AIPlayer(){
		id = Enum.PLAYERAI;
	}

	public void setField(FieldCell[][] f){
		field = f;
	}

	public void decideNextMove(){

		Random r = new Random();
		FieldCell cell = (snake.getHead()).getPosition();

		int odir = snake.getHead().getDirection();
		int type;

		// Checks if there is a FiedlBerry of SawBerry close by
		for (int d=0; d<Enum.NUMNEIGHBOURS; d++){
//			if (cell==null)
//				return;
			type = (cell.getNeighbour(d)).getContentType();
			if (type == Enum.FIELDBERRY || type == Enum.SAWBERRY){
				(snake.getHead()).setDirection(d);
				return;
			}
		}
	
		// No berry close, checks if next move is safe
		boolean safe = false;
		type = (cell.getNeighbour(odir)).getContentType();
		// Safe, if snake is berserked and the snakepart there contains no stone
		if ((SnakeState.isBerserked(snake.getState())) && (type == Enum.SNAKEHEAD || type == Enum.SNAKEBODY) && !(((SnakePart)((cell.getNeighbour(odir)).getContent())).getStoneStatus()))
			safe = true;
		// Safe, if snake is berserked and the dead snakepart there contains no stone
		else if ((SnakeState.isBerserked(snake.getState())) && (type == Enum.DEADSNAKEBODY) && !(((SnakeDead)((cell.getNeighbour(odir)).getContent())).getStoneStatus()))
			safe = true;
		// Safe, if there are no dead or alive snakeparts or wall
		else if (type != Enum.SNAKEHEAD && type != Enum.SNAKEBODY && type != Enum.DEADSNAKEHEAD && type != Enum.DEADSNAKEBODY && type != Enum.WALL)
			safe = true;
		if (safe){
			int change = r.nextInt(100);
			// There is a 95% chance that it will turn meaning:
			// (1-0.95^1)*100 => there is a  5.00% chance that it will turn after 1 move
			// (1-0.95^2)*100 => there is a  9.75% chance that it will turn after 2 moves
			// (1-0.95^3)*100 => there is a 14.26% chance that it will turn after 3 moves
			// (1-0.95^4)*100 => there is a 18.55% chance that it will turn after 4 moves
			// (1-0.95^5)*100 => there is a 22.62% chance that it will turn after 5 moves
			// (1-0.95^6)*100 => there is a 26.49% chance that it will turn after 6 moves
			// (1-0.95^7)*100 => there is a 30.17% chance that it will turn after 7 moves
			// (1-0.95^8)*100 => there is a 33.66% chance that it will turn after 8 moves
			// (1-0.95^9)*100 => there is a 36.98% chance that it will turn after 9 moves
			if (change < 95)
				return;
		}

		// Decides on a new next move
		int c = (snake.field).getCellID(cell);
		//(snake.getHead()).setDirection(Enum.RIGHT);
		int dir = r.nextInt(Enum.NUMNEIGHBOURS);
		for (int d=0; d<Enum.NUMNEIGHBOURS && dir<Enum.NUMNEIGHBOURS; d++){
			dir++; dir = dir%Enum.NUMNEIGHBOURS;
			type = (cell.getNeighbour(dir)).getContentType();
			if ((SnakeState.isBerserked(snake.getState())) &&
			    (type == Enum.SNAKEHEAD || type == Enum.SNAKEBODY) && 
				!(((SnakePart)((cell.getNeighbour(dir)).getContent())).getStoneStatus()) && 
				((((SnakePart)((cell.getNeighbour(dir)).getContent())).getSnake()).getID() != snake.getID())){
				if (noBackwards(odir, dir)){
					(snake.getHead()).setDirection(dir);
					return;
				}
			}
			else if (type != Enum.SNAKEHEAD && type != Enum.SNAKEBODY && type != Enum.WALL){
				(snake.getHead()).setDirection(dir);
				return;
			}
		}
	}

/**
 * Checks if next move is towards the snake's own first bodypart 
 */
	private boolean noBackwards(int dold, int dnew){
		// If snake only has a head, it can turn anywhere
		if (snake.getHead().getNext() == null)
			return true;
		// AI changes the direction only once, so it can
		// simply compare the next move to the new move
		switch(dold){
			case Enum.UP:
				if (dnew == Enum.DOWN) return false;
				break;
			case Enum.RIGHT:
				if (dnew == Enum.LEFT) return false;
				break;
			case Enum.DOWN:
				if (dnew == Enum.UP) return false;
				break;
			case Enum.LEFT:
				if (dnew == Enum.RIGHT) return false;
				break;
		}
		return true;
	}



// Ideas:
// We should use dijsktra. From AI's snake's current position
// the closest berry is searched. It will move to the
// neighbours of the cells until it finds a berry or
// nothing. In case of nothing the next move will be random
// but not towards a wall or other snake if not being
// berserked.
// This will be the decideNextRoute.
// decideNextMove will try to move along the route given
// by the decideNextRoute. It the next move is not valid
// (a snake moved there and it's not in berserked state 
// or the destination point's berry disappeared),
// it will ask for another route.




}
