// DONE
/**
 * Class Berry
 * The parent of all berries.
 * Handles the creation and destruction of Berries.
 */

public abstract class Berry implements IContent {

	// Time before the Berry is destroyed (measurement is in tick).
	protected int timeLeftBeforeDestroy;

	// Number of Berry objects
	public static int idnum = 0;

	// ID of an exact Berry object
	protected int id;

	// Field
	protected Field field;

	// Type of IContent
	public int type;


/**
 * Class constructor.
 */
	public Berry(){
	}



/**
 * Handles the destruction of the berry.
 */  
	public void destroy(){
		field.removeBerryContent(id);
	}
	


/**
 * Returns id.
 */
	public int getID(){
		return id;
	}



/**
 * Gets time before destroy
 */
	public int getTimeBeforeDestroy(){
		return timeLeftBeforeDestroy;
	}



/**
 * Gets time before destroy
 */
	public void decreaseTimeBeforeDestroy(){
		timeLeftBeforeDestroy--;
		if (timeLeftBeforeDestroy == 0)
			this.destroy();
	}



}

