/**
 * Class Controller
 * The parent of AI and HumanPalyer
 * Handles the controlling of the game.
 */
public abstract class Controller{

	// The controller's snake
	public Snake snake;

	// Point of this controller
	int points = 0;

	// Direction the snake will move towards at the next tick.
	int direction = 0;

	// number of snake objects
	public static int idnum = 0;

	// id of a controller
	public int id;

	/**
	 * Class constructor.
	 */
	public Controller(){
	}

	/**
	 * It returns the Snake controlled by this controller.
	 *
	 * @return snake The snake controlled by this controller.
	 */
	public Snake getSnake(){
		return snake;
	}

	/**
	 * @param s The snake that will be controlled by this controller.
	 */
	public void setSnake(Snake s){
		snake = s;
		snake.setController(id);
	}

}
