// DONE
/**
 * Class Draw
 * Proto version of drawing. It will be upgraded
 * for the Graphical version.
 */
class Draw{



	public static void drawField(FieldCell[] cells, int width, int height){

		System.out.println("");

		// Sets cells' neighbours
		FieldCell[][] tmp;
		tmp = new FieldCell[width][height];
		for (int k=0, i=0; k<height; k++){
			for (int j=0; j<width; j++){
				tmp[j][k] = cells[i];
				i++;
			}
		}

		// Draws the ASCII-Field

		System.out.print("/");
		for (int j=0; j<width; j++) System.out.print("-");
		System.out.print("\\");
		for (int k=0, i=0; k<height; k++){
			System.out.print("\n|");
			for (int j=0; j<width; j++){
				int content = cells[i].getContentType();
				// Checks the content
				switch(content){
					case Enum.EMPTY:         System.out.print("."); break;
					case Enum.WALL:          System.out.print("#"); break;
					case Enum.FIELDBERRY:    System.out.print("f"); break;
					case Enum.SAWBERRY:      System.out.print("s"); break;
					case Enum.STONEBERRY:    System.out.print("t"); break;
					case Enum.SNAKEHEAD:
						if (((SnakeHead)(cells[i].getContent())).getStoneStatus()){
							int dir = ((SnakeHead)(cells[i].getContent())).getDirection();
							switch(dir){
								case Enum.UP:    System.out.print("U"); break;
								case Enum.RIGHT: System.out.print("R"); break;
								case Enum.DOWN:  System.out.print("D"); break;
								case Enum.LEFT:  System.out.print("L"); break;
								default:         System.out.print("Q"); break;
							}

						}
						else{
							int dir = ((SnakeHead)(cells[i].getContent())).getDirection();
							switch(dir){
								case Enum.UP:    System.out.print("u"); break;
								case Enum.RIGHT: System.out.print("r"); break;
								case Enum.DOWN:  System.out.print("d"); break;
								case Enum.LEFT:  System.out.print("l"); break;
								default:         System.out.print("O"); break;
							}
						}
						break;
					case Enum.SNAKEBODY:
						int dir = ((SnakeBody)(cells[i].getContent())).getDirection();
							System.out.print(dir);
						break;
					case Enum.DEADSNAKEHEAD:
						if (((SnakeDead)(cells[i].getContent())).getStoneStatus())
							System.out.print("Y");
						else System.out.print("X");
						break;
					case Enum.DEADSNAKEBODY:
						if (((SnakeDead)(cells[i].getContent())).getStoneStatus())
							System.out.print("y");
						else System.out.print("x");
						break;
					default: System.out.print("?"); break;
				}
				i++;
			}
			System.out.print("|");
		}
		System.out.println("");
		System.out.print("\\");
		for (int j=0; j<width; j++) System.out.print("-");
		System.out.print("/");
		System.out.println("\n");
	}



}

