/**
 * Class Enum
 * Contains the Enumerators of the game.
 */
final class Enum{

// IContents
	public static final int EMPTY         = 0;
	public static final int WALL          = 1;
	public static final int FIELDBERRY    = 2;
	public static final int SAWBERRY      = 3;
	public static final int STONEBERRY    = 4;
	public static final int SNAKEHEAD     = 5;
	public static final int SNAKEBODY     = 6;
	public static final int UNKNOWN       = 7;
	public static final int DEADSNAKEHEAD = 8;
	public static final int DEADSNAKEBODY = 9;

// Directions (there are as many directions as Neighbours)
	public static final int NUMNEIGHBOURS = 4;
 	public static final int UP    = 0;
	public static final int RIGHT = 1;
	public static final int DOWN  = 2;
	public static final int LEFT  = 3;

// Field's stats
	public static final int WIDTHMIN  = 10;
	public static final int WIDTHMAX  = 28;
	public static final int HEIGHTMIN = 10;
	public static final int HEIGHTMAX = 28;

// dead snake part's decay time
	public static final int SNAKEMINDECAY    =  20;
	public static final int SNAKERANDOMDECAY = 100;

// Snakes' initial length
// Can be changed in the game
	public static int SNAKELENGTH = 2;

// Tick's length given in millisecundum (1/1000 s)
	public static final int TICKTIME = 100;
// How many ticks does it take to a snake to move
// given in tick
// Can be changed in the game
	public static int SNAKEMOVETIME = 5;
// How long a snake remains berserked given in tick
// Can be changed in the game
	public static int BERSERKEDTIME = 100;
// Stone's rolling time given in tick
// Can be changed in the game
	public static int STONEROLLTIME = 2;
// Berry appearing & life time on the field
// Can be changed in the game
	public static int TMINFIELD    = 10;
	public static int TRANDOMFIELD = 20;
	public static int TMINSAW      = 20;
	public static int TRANDOMSAW   = 20;
	public static int TMINSTONE    = 20;
	public static int TRANDOMSTONE = 20;
	public static int BERRYLIFETIME = 100;

// Controller
	public static final int PLAYER1      = 0;
	public static final int PLAYER2      = 1;
	public static final int PLAYER3      = 2;
	public static final int PLAYER4      = 3;
	public static final int PLAYERAI     = 4;
	public static final int NOCONTROLLER = 5;

// Controlling Keys
	public static final int PAUSE     = java.awt.event.KeyEvent.VK_PAUSE;
	public static final int SPEEDUP   = java.awt.event.KeyEvent.VK_PAGE_UP;
	public static final int SPEEDDOWN = java.awt.event.KeyEvent.VK_PAGE_DOWN;
	public static final int STONEUP   = java.awt.event.KeyEvent.VK_HOME;
	public static final int STONEDOWN = java.awt.event.KeyEvent.VK_END;
	public static final int PL1_UP    = java.awt.event.KeyEvent.VK_UP;
	public static final int PL1_RIGHT = java.awt.event.KeyEvent.VK_RIGHT;
	public static final int PL1_DOWN  = java.awt.event.KeyEvent.VK_DOWN;
	public static final int PL1_LEFT  = java.awt.event.KeyEvent.VK_LEFT;
	public static final int PL2_UP    = java.awt.event.KeyEvent.VK_NUMPAD8;
	public static final int PL2_RIGHT = java.awt.event.KeyEvent.VK_NUMPAD6;
	public static final int PL2_DOWN  = java.awt.event.KeyEvent.VK_NUMPAD5;
	public static final int PL2_LEFT  = java.awt.event.KeyEvent.VK_NUMPAD4;
	public static final int PL3_UP    = java.awt.event.KeyEvent.VK_I;
	public static final int PL3_RIGHT = java.awt.event.KeyEvent.VK_L;
	public static final int PL3_DOWN  = java.awt.event.KeyEvent.VK_K;
	public static final int PL3_LEFT  = java.awt.event.KeyEvent.VK_J;
	public static final int PL4_UP    = java.awt.event.KeyEvent.VK_W;
	public static final int PL4_RIGHT = java.awt.event.KeyEvent.VK_D;
	public static final int PL4_DOWN  = java.awt.event.KeyEvent.VK_S;
	public static final int PL4_LEFT  = java.awt.event.KeyEvent.VK_A;
	public static final int EXIT      = java.awt.event.KeyEvent.VK_ESCAPE;

// Number of players
	public static final int HUPLAYERMIN = 1;
	public static final int HUPLAYERMAX = 4;
	public static final int AIPLAYERMIN = 0;
	public static final int AIPLAYERMAX = 5;

// Graphics
	// Content graphics's size, translation from origo, border's size
	public static final int G_PIXEL  =  16;
	public static final int G_MENUX  = 183;
	public static final int G_MENUY  = 413;
	public static final int G_BGX    = 500;
	public static final int G_BGY    = 500;
	public static int G_TRANSLATEX   =   0;
	public static int G_TRANSLATEY   =   0;

	// Number of content graphics
	public static final int G_NUM                                = 85;
	// Empty field's graphics
	public static final int G_EMPTY                              =  0;
	// Wall's graphics
	public static final int G_WALL                               =  1;
	// Berries' graphivs
	public static final int G_FIELDBERRY                         =  2;
	public static final int G_SAWBERRY                           =  3;
	public static final int G_STONEBERRY                         =  4;
	// Dead snake's graphics
	public static final int G_SNAKE_DEAD_HEAD                    =  5;
	public static final int G_SNAKE_DEAD_HEAD_STONE              =  6;
	public static final int G_SNAKE_DEAD_HEAD_END                =  7;
	public static final int G_SNAKE_DEAD_HEAD_END_STONE          =  8;
	public static final int G_SNAKE_DEAD_LINEAR                  =  9;
	public static final int G_SNAKE_DEAD_LINEAR_STONE            = 10;
	public static final int G_SNAKE_DEAD_BENT                    = 11;
	public static final int G_SNAKE_DEAD_BENT_STONE              = 12;
	public static final int G_SNAKE_DEAD_END                     = 13;
	public static final int G_SNAKE_DEAD_END_STONE               = 14;
	// AI players' snake graphics
	public static final int G_SNAKE_AI_HEAD                      = 15;
	public static final int G_SNAKE_AI_HEAD_BERSERKED            = 16;
	public static final int G_SNAKE_AI_HEAD_STONE                = 17;
	public static final int G_SNAKE_AI_HEAD_STONE_BERSERKED      = 18;
	public static final int G_SNAKE_AI_HEAD_END                  = 19;
	public static final int G_SNAKE_AI_HEAD_END_BERSERKED        = 20;
	public static final int G_SNAKE_AI_HEAD_END_STONE            = 21;
	public static final int G_SNAKE_AI_HEAD_END_STONE_BERSERKED  = 22;
	public static final int G_SNAKE_AI_LINEAR                    = 23;
	public static final int G_SNAKE_AI_LINEAR_STONE              = 24;
	public static final int G_SNAKE_AI_BENT                      = 25;
	public static final int G_SNAKE_AI_BENT_STONE                = 26;
	public static final int G_SNAKE_AI_END                       = 27;
	public static final int G_SNAKE_AI_END_STONE                 = 28;
	// Player1's snake graphics
	public static final int G_SNAKE_PL1_HEAD                     = 29;
	public static final int G_SNAKE_PL1_HEAD_BERSERKED           = 30;
	public static final int G_SNAKE_PL1_HEAD_STONE               = 31;
	public static final int G_SNAKE_PL1_HEAD_STONE_BERSERKED     = 32;
	public static final int G_SNAKE_PL1_HEAD_END                 = 33;
	public static final int G_SNAKE_PL1_HEAD_END_BERSERKED       = 34;
	public static final int G_SNAKE_PL1_HEAD_END_STONE           = 35;
	public static final int G_SNAKE_PL1_HEAD_END_STONE_BERSERKED = 36;
	public static final int G_SNAKE_PL1_LINEAR                   = 37;
	public static final int G_SNAKE_PL1_LINEAR_STONE             = 38;
	public static final int G_SNAKE_PL1_BENT                     = 39;
	public static final int G_SNAKE_PL1_BENT_STONE               = 40;
	public static final int G_SNAKE_PL1_END                      = 41;
	public static final int G_SNAKE_PL1_END_STONE                = 42;
	// Player2's snake graphics
	public static final int G_SNAKE_PL2_HEAD                     = 43;
	public static final int G_SNAKE_PL2_HEAD_BERSERKED           = 44;
	public static final int G_SNAKE_PL2_HEAD_STONE               = 45;
	public static final int G_SNAKE_PL2_HEAD_STONE_BERSERKED     = 46;
	public static final int G_SNAKE_PL2_HEAD_END                 = 47;
	public static final int G_SNAKE_PL2_HEAD_END_BERSERKED       = 48;
	public static final int G_SNAKE_PL2_HEAD_END_STONE           = 49;
	public static final int G_SNAKE_PL2_HEAD_END_STONE_BERSERKED = 50;
	public static final int G_SNAKE_PL2_LINEAR                   = 51;
	public static final int G_SNAKE_PL2_LINEAR_STONE             = 52;
	public static final int G_SNAKE_PL2_BENT                     = 53;
	public static final int G_SNAKE_PL2_BENT_STONE               = 54;
	public static final int G_SNAKE_PL2_END                      = 55;
	public static final int G_SNAKE_PL2_END_STONE                = 56;
	// Player3's snake graphics
	public static final int G_SNAKE_PL3_HEAD                     = 57;
	public static final int G_SNAKE_PL3_HEAD_BERSERKED           = 58;
	public static final int G_SNAKE_PL3_HEAD_STONE               = 59;
	public static final int G_SNAKE_PL3_HEAD_STONE_BERSERKED     = 60;
	public static final int G_SNAKE_PL3_HEAD_END                 = 61;
	public static final int G_SNAKE_PL3_HEAD_END_BERSERKED       = 62;
	public static final int G_SNAKE_PL3_HEAD_END_STONE           = 63;
	public static final int G_SNAKE_PL3_HEAD_END_STONE_BERSERKED = 64;
	public static final int G_SNAKE_PL3_LINEAR                   = 65;
	public static final int G_SNAKE_PL3_LINEAR_STONE             = 66;
	public static final int G_SNAKE_PL3_BENT                     = 67;
	public static final int G_SNAKE_PL3_BENT_STONE               = 68;
	public static final int G_SNAKE_PL3_END                      = 69;
	public static final int G_SNAKE_PL3_END_STONE                = 70;
	// Player4's snake graphics
	public static final int G_SNAKE_PL4_HEAD                     = 71;
	public static final int G_SNAKE_PL4_HEAD_BERSERKED           = 72;
	public static final int G_SNAKE_PL4_HEAD_STONE               = 73;
	public static final int G_SNAKE_PL4_HEAD_STONE_BERSERKED     = 74;
	public static final int G_SNAKE_PL4_HEAD_END                 = 75;
	public static final int G_SNAKE_PL4_HEAD_END_BERSERKED       = 76;
	public static final int G_SNAKE_PL4_HEAD_END_STONE           = 77;
	public static final int G_SNAKE_PL4_HEAD_END_STONE_BERSERKED = 78;
	public static final int G_SNAKE_PL4_LINEAR                   = 79;
	public static final int G_SNAKE_PL4_LINEAR_STONE             = 80;
	public static final int G_SNAKE_PL4_BENT                     = 81;
	public static final int G_SNAKE_PL4_BENT_STONE               = 82;
	public static final int G_SNAKE_PL4_END                      = 83;
	public static final int G_SNAKE_PL4_END_STONE                = 84;


}
