

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.image.BufferedImage;

import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;

import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

public class RenderTarget extends JPanel {

	private BufferedImage  logo;
	private BufferedImage[] cimg;
	


	public RenderTarget() {
		logo = null;
		cimg = new BufferedImage[Enum.G_NUM];
		try {
			logo = ImageIO.read(new File("graphics"+File.separator+"logo.png"));
			cimg[Enum.G_EMPTY]                              = ImageIO.read(new File("graphics"+File.separator+"field"+File.separator+"field.png"));
			cimg[Enum.G_WALL]                               = ImageIO.read(new File("graphics"+File.separator+"wall"+File.separator+"wall.png"));
			cimg[Enum.G_FIELDBERRY]                         = ImageIO.read(new File("graphics"+File.separator+"berry"+File.separator+"fieldberry.png"));
			cimg[Enum.G_SAWBERRY]                           = ImageIO.read(new File("graphics"+File.separator+"berry"+File.separator+"sawberry.png"));
			cimg[Enum.G_STONEBERRY]                         = ImageIO.read(new File("graphics"+File.separator+"berry"+File.separator+"stoneberry.png"));
			cimg[Enum.G_SNAKE_DEAD_HEAD]                    = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"dead-snake_head.png"));
			cimg[Enum.G_SNAKE_DEAD_HEAD_STONE]              = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"dead-snake_head_stone.png"));
			cimg[Enum.G_SNAKE_DEAD_HEAD_END]                = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"dead-snake_head_end.png"));
			cimg[Enum.G_SNAKE_DEAD_HEAD_END_STONE]          = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"dead-snake_head_stone_end.png"));
			cimg[Enum.G_SNAKE_DEAD_LINEAR]                  = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"dead-snake_linear.png"));
			cimg[Enum.G_SNAKE_DEAD_LINEAR_STONE]            = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"dead-snake_linear_stone.png"));
			cimg[Enum.G_SNAKE_DEAD_BENT]                    = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"dead-snake_bent.png"));
			cimg[Enum.G_SNAKE_DEAD_BENT_STONE]              = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"dead-snake_bent_stone.png"));
			cimg[Enum.G_SNAKE_DEAD_END]                     = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"dead-snake_end.png"));
			cimg[Enum.G_SNAKE_DEAD_END_STONE]               = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"dead-snake_end_stone.png"));
			cimg[Enum.G_SNAKE_AI_HEAD]                      = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"ai-snake_head.png"));
			cimg[Enum.G_SNAKE_AI_HEAD_BERSERKED]            = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"ai-snake_head_berserked.png"));
			cimg[Enum.G_SNAKE_AI_HEAD_STONE]                = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"ai-snake_head_stone.png"));
			cimg[Enum.G_SNAKE_AI_HEAD_STONE_BERSERKED]      = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"ai-snake_head_stone_berserked.png"));
			cimg[Enum.G_SNAKE_AI_HEAD_END]                  = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"ai-snake_head_end.png"));
			cimg[Enum.G_SNAKE_AI_HEAD_END_BERSERKED]        = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"ai-snake_head_berserked_end.png"));
			cimg[Enum.G_SNAKE_AI_HEAD_END_STONE]            = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"ai-snake_head_stone_end.png"));
			cimg[Enum.G_SNAKE_AI_HEAD_END_STONE_BERSERKED]  = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"ai-snake_head_stone_berserked_end.png"));
			cimg[Enum.G_SNAKE_AI_LINEAR]                    = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"ai-snake_linear.png"));
			cimg[Enum.G_SNAKE_AI_LINEAR_STONE]              = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"ai-snake_linear_stone.png"));
			cimg[Enum.G_SNAKE_AI_BENT]                      = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"ai-snake_bent.png"));
			cimg[Enum.G_SNAKE_AI_BENT_STONE]                = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"ai-snake_bent_stone.png"));
			cimg[Enum.G_SNAKE_AI_END]                       = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"ai-snake_end.png"));
			cimg[Enum.G_SNAKE_AI_END_STONE]                 = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"ai-snake_end_stone.png"));
			cimg[Enum.G_SNAKE_PL1_HEAD]                     = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl1-snake_head.png"));
			cimg[Enum.G_SNAKE_PL1_HEAD_BERSERKED]           = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl1-snake_head_berserked.png"));
			cimg[Enum.G_SNAKE_PL1_HEAD_STONE]               = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl1-snake_head_stone.png"));
			cimg[Enum.G_SNAKE_PL1_HEAD_STONE_BERSERKED]     = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl1-snake_head_stone_berserked.png"));
			cimg[Enum.G_SNAKE_PL1_HEAD_END]                 = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl1-snake_head_end.png"));
			cimg[Enum.G_SNAKE_PL1_HEAD_END_BERSERKED]       = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl1-snake_head_berserked_end.png"));
			cimg[Enum.G_SNAKE_PL1_HEAD_END_STONE]           = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl1-snake_head_stone_end.png"));
			cimg[Enum.G_SNAKE_PL1_HEAD_END_STONE_BERSERKED] = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl1-snake_head_stone_berserked_end.png"));
			cimg[Enum.G_SNAKE_PL1_LINEAR]                   = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl1-snake_linear.png"));
			cimg[Enum.G_SNAKE_PL1_LINEAR_STONE]             = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl1-snake_linear_stone.png"));
			cimg[Enum.G_SNAKE_PL1_BENT]                     = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl1-snake_bent.png"));
			cimg[Enum.G_SNAKE_PL1_BENT_STONE]               = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl1-snake_bent_stone.png"));
			cimg[Enum.G_SNAKE_PL1_END]                      = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl1-snake_end.png"));
			cimg[Enum.G_SNAKE_PL1_END_STONE]                = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl1-snake_end_stone.png"));
			cimg[Enum.G_SNAKE_PL2_HEAD]                     = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl2-snake_head.png"));
			cimg[Enum.G_SNAKE_PL2_HEAD_BERSERKED]           = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl2-snake_head_berserked.png"));
			cimg[Enum.G_SNAKE_PL2_HEAD_STONE]               = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl2-snake_head_stone.png"));
			cimg[Enum.G_SNAKE_PL2_HEAD_STONE_BERSERKED]     = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl2-snake_head_stone_berserked.png"));
			cimg[Enum.G_SNAKE_PL2_HEAD_END]                 = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl2-snake_head_end.png"));
			cimg[Enum.G_SNAKE_PL2_HEAD_END_BERSERKED]       = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl2-snake_head_berserked_end.png"));
			cimg[Enum.G_SNAKE_PL2_HEAD_END_STONE]           = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl2-snake_head_stone_end.png"));
			cimg[Enum.G_SNAKE_PL2_HEAD_END_STONE_BERSERKED] = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl2-snake_head_stone_berserked_end.png"));
			cimg[Enum.G_SNAKE_PL2_LINEAR]                   = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl2-snake_linear.png"));
			cimg[Enum.G_SNAKE_PL2_LINEAR_STONE]             = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl2-snake_linear_stone.png"));
			cimg[Enum.G_SNAKE_PL2_BENT]                     = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl2-snake_bent.png"));
			cimg[Enum.G_SNAKE_PL2_BENT_STONE]               = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl2-snake_bent_stone.png"));
			cimg[Enum.G_SNAKE_PL2_END]                      = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl2-snake_end.png"));
			cimg[Enum.G_SNAKE_PL2_END_STONE]                = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl2-snake_end_stone.png"));
			cimg[Enum.G_SNAKE_PL3_HEAD]                     = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl3-snake_head.png"));
			cimg[Enum.G_SNAKE_PL3_HEAD_BERSERKED]           = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl3-snake_head_berserked.png"));
			cimg[Enum.G_SNAKE_PL3_HEAD_STONE]               = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl3-snake_head_stone.png"));
			cimg[Enum.G_SNAKE_PL3_HEAD_STONE_BERSERKED]     = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl3-snake_head_stone_berserked.png"));
			cimg[Enum.G_SNAKE_PL3_HEAD_END]                 = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl3-snake_head_end.png"));
			cimg[Enum.G_SNAKE_PL3_HEAD_END_BERSERKED]       = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl3-snake_head_berserked_end.png"));
			cimg[Enum.G_SNAKE_PL3_HEAD_END_STONE]           = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl3-snake_head_stone_end.png"));
			cimg[Enum.G_SNAKE_PL3_HEAD_END_STONE_BERSERKED] = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl3-snake_head_stone_berserked_end.png"));
			cimg[Enum.G_SNAKE_PL3_LINEAR]                   = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl3-snake_linear.png"));
			cimg[Enum.G_SNAKE_PL3_LINEAR_STONE]             = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl3-snake_linear_stone.png"));
			cimg[Enum.G_SNAKE_PL3_BENT]                     = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl3-snake_bent.png"));
			cimg[Enum.G_SNAKE_PL3_BENT_STONE]               = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl3-snake_bent_stone.png"));
			cimg[Enum.G_SNAKE_PL3_END]                      = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl3-snake_end.png"));
			cimg[Enum.G_SNAKE_PL3_END_STONE]                = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl3-snake_end_stone.png"));
			cimg[Enum.G_SNAKE_PL4_HEAD]                     = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl4-snake_head.png"));
			cimg[Enum.G_SNAKE_PL4_HEAD_BERSERKED]           = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl4-snake_head_berserked.png"));
			cimg[Enum.G_SNAKE_PL4_HEAD_STONE]               = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl4-snake_head_stone.png"));
			cimg[Enum.G_SNAKE_PL4_HEAD_STONE_BERSERKED]     = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl4-snake_head_stone_berserked.png"));
			cimg[Enum.G_SNAKE_PL4_HEAD_END]                 = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl4-snake_head_end.png"));
			cimg[Enum.G_SNAKE_PL4_HEAD_END_BERSERKED]       = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl4-snake_head_berserked_end.png"));
			cimg[Enum.G_SNAKE_PL4_HEAD_END_STONE]           = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl4-snake_head_stone_end.png"));
			cimg[Enum.G_SNAKE_PL4_HEAD_END_STONE_BERSERKED] = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl4-snake_head_stone_berserked_end.png"));
			cimg[Enum.G_SNAKE_PL4_LINEAR]                   = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl4-snake_linear.png"));
			cimg[Enum.G_SNAKE_PL4_LINEAR_STONE]             = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl4-snake_linear_stone.png"));
			cimg[Enum.G_SNAKE_PL4_BENT]                     = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl4-snake_bent.png"));
			cimg[Enum.G_SNAKE_PL4_BENT_STONE]               = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl4-snake_bent_stone.png"));
			cimg[Enum.G_SNAKE_PL4_END]                      = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl4-snake_end.png"));
			cimg[Enum.G_SNAKE_PL4_END_STONE]                = ImageIO.read(new File("graphics"+File.separator+"snake"+File.separator+"pl4-snake_end_stone.png"));
		} catch (IOException ioex) {
			JOptionPane.showMessageDialog(null, ioex.toString());
		}
	}
    

	public BufferedImage getContentImage(int c){
		return cimg[c];
	}


	public void paint(Graphics g) {
		g.drawImage(logo, 0, 0, null);
    }
    


	public void paintComponent(Graphics g) {
		this.paint(g);
	}
}
