import java.awt.Graphics;

/**
 * Class Renderer
 * It manages rendering as a whole,
 * Game calls it in every tick;
 * It has as many CellRenderer,
 * as Field has FieldCells.
 */
public class Renderer{

	// references to the cells
	private CellRenderer[] cellRenderers;
	private RenderTarget renderTarget;

	public Renderer(RenderTarget rt){
		renderTarget = rt;
	}

	public void init(int width, int height, FieldCell[][] fc){
		Enum.G_TRANSLATEX = (Enum.G_BGX-width*Enum.G_PIXEL)/2;
		Enum.G_TRANSLATEY = (Enum.G_BGY-height*Enum.G_PIXEL)/2;
		cellRenderers = new CellRenderer[width*height];
		int n = 0;
		for (int i=0; i<height; i++){
			for (int k=0; k<width; k++){
				int px = (k*Enum.G_PIXEL);
				int py = (i*Enum.G_PIXEL);
				cellRenderers[n] = new CellRenderer(fc[k][i], px, py);
				n++;
			}
		}
	}

	public void renderScene(){
		Graphics g = renderTarget.getGraphics();
		for (int i=0; i<cellRenderers.length; i++){
			cellRenderers[i].render(g, renderTarget);
		}
	}

}
