/**
 * Class SawBerry
 * Represents a SawBerry on the playing field.
 * Handles collisions with snakes, and affects
 * them.
 */
public class SawBerry extends Berry {



/**
 * Class constructor.
 *
 * @param f Reference to the Field.
 */
    public SawBerry(Field f) {
		type = Enum.SAWBERRY;
		field = f;
		id = idnum;
		idnum++;
		timeLeftBeforeDestroy = Enum.BERRYLIFETIME;
    }



/**
 * Reacts to the collision.
 *
 * @param s The Snake's reference that collided with the SawBerry.
 */
    public void reactToCollision(Snake s) {
		//Callback to the Snake that collided with this FieldBerry
		s.collideWithSawBerry();
		//Colliding with a Snake destroys this FieldBerry
		destroy();
    }



/**
 * Returns the type of IContent.
 */
	public int getType(){
		return type;
	}



}
