/**
 * Class SnakeBody
 * Represents a Snake's body. A Snake's body is made up of
 * zero or several SnakeBody instances, each occupying
 * a FieldCell.
 */
public class SnakeBody extends SnakePart {



/**
 * Class constructor.
 */
    public SnakeBody(Snake s){
		id = idnum; idnum++;
		type = Enum.SNAKEBODY;
		snake = s;
		hasStone = false;
		nextBodyElement = null;
    }



/**
 * Gets length
 */
	public int getLength(int length){
		length++;
		if (nextBodyElement != null)
			return nextBodyElement.getLength(length);
		else return length;
	}



/**
 * Gets number of stones
 */
	public int getNumOfStones(int stones){
		if (hasStone)
			stones++;
		if (nextBodyElement != null)
			return nextBodyElement.getNumOfStones(stones);
		else return stones;
	}



/**
 * Snake moves to the next field.
 */
	public void move(FieldCell moveto, boolean grow){
		if (nextBodyElement != null){
			nextBodyElement.move(cell, grow);
		}
		if (nextBodyElement == null){
			if (grow){
				nextBodyElement = new SnakeBody(snake);
				nextBodyElement.setPosition(cell);
				nextBodyElement.setPrev(this);
				nextBodyElement.setDirection(direction);
				cell.updateContent(nextBodyElement);
			}
			else
				cell.updateContent(new Empty());
		}
		direction = prevBodyElement.getDirection();
		cell = moveto;
		cell.updateContent(this);
	}



}
