// DONE

import java.util.Random;

/**
 * Class SnakeDead
 * Represents a Snake's dead bodypart, which
 * can contain stone.
 */
public class SnakeDead implements IContent {

	//Type of IContent
	public int type;

	// Decay
	public int decay;

	// Position on the field
	FieldCell pos;

	// number of snake objects
	public static int idnum = 0;

	// id of an exact snake object
	public int id;

	//Indicates whether this body element contains a stone or not.
	protected boolean hasStone;

	// Direction of original snakepart
	private int ownDir;

	// Direction of next snakepart, -1 if there's none
	private int nextDir;

/**
 * Class constructor.
 */
    public SnakeDead(int t, FieldCell p, boolean st, int od, int nd, int n){
		pos = p;
		type = t;
		id = idnum; idnum++;
		hasStone = st;
		Random r = new Random();
		ownDir = od;
		nextDir = nd;
		int random = Enum.SNAKERANDOMDECAY;
		for (int i=0; i<n; i++)
			random = r.nextInt(Enum.SNAKERANDOMDECAY); 
		decay = Enum.SNAKEMINDECAY + random;
    }



/**
 * Handles the destruction of the dead snake's bodypart.
 */
	public void destroy(){
	}



/**
 * Gets status.
 */
	public void getStatus(){
	}



/**
 *  Reacts to the collision.
 *
 * @param s The Snake's reference that collided with the Wall.
 */
	public void reactToCollision(Snake s){
		if (hasStone)
			s.collideWithStonedDeadBody();
		else
			s.collideWithDeadBody();
    }



/**
 * Returns the type of IContent
 */
	public int getType(){
		return type;
	}



/**
 * Returns true if the bodypart contains stone,
 * false if not.
 */
	public boolean getStoneStatus(){
		return hasStone;
	}



/**
 * Returns id.
 */
	public int getID(){
		return id;
	}



/**
 * Returns if it has next body element or not.
 */
	public boolean hasNext(){
		if (nextDir == -1)
			return false;
		return true;
	}



/**
 * Returns direction.
 */
	public int getDirection(){
		return ownDir;
	}



/**
 * Returns next part's direction.
 */
	public int getNextDirection(){
		return nextDir;
	}


/**
 * Decays in time.
 */
	public void decay(){
		decay--;
		if (decay == 0){
			pos.updateContent(new Empty());
		}
	}



}
