// DONE
/**
 * Class SnakeState
 * Contains the possible states of the snake.
 * Can determine if a state is set or not.
 */
final class SnakeState{

	public static final int STATE_NORMAL       = 0; // 00
	public static final int STATE_BERSERKED    = 1; // 01
	public static final int STATE_FULLOFSTONES = 2; // 10



/** 
 * Determines if the state is NORMAL.
 *
 * @param state The state to examine.
 */
	public static boolean isNormal(int state){
		return (state == STATE_NORMAL);
	}



/**
 * Determines if the state is BERSERKED.
 *
 * @param state The state to examine.
 */
	public static boolean isBerserked(int state){
		return ((state & STATE_BERSERKED) == STATE_BERSERKED);
	}



/**
 * Determines if the state is FULLOFSTONE.
 *
 * @param state The state to examine.
 */
	public static boolean isFullOfStones(int state){	
		return ((state & STATE_FULLOFSTONES) == STATE_FULLOFSTONES);
	}



}

