// DONE
/**
 * Class StoneBerry
 * Represents a stoneberry found on the game
 * field. Handles the collision with a Snake.
 */
public class StoneBerry extends Berry {



/**
 * Class constructor.
 *
 * @param f reference to the Field
 */
	public StoneBerry(Field f){
		type = Enum.STONEBERRY;
		field = f;
		id = idnum;
		idnum++;
		timeLeftBeforeDestroy = Enum.BERRYLIFETIME;
	}



/**
 * Reacts to the collision.
 *
 * @param s The Snake's reference that collided with the Empty.
 */
	public void reactToCollision(Snake s){
		//Callback to the Snake that collided with this StoneBerry
		s.collideWithStoneBerry();
		//Colliding with a Snake destroys this StoneBerry
		destroy();
	}



/**
 * Returns the type of IContent
 */
	public int getType(){
		return type;
	}



}
