// DONE
/**
 * Class Wall
 * Represents a Wall on the game field.
 * Calls back the colliding Snakes telling them
 * they collided with a Wall.
 */
public class Wall implements IContent {

	// Type of IContent
	public int type;

/**
 * Class constructor.
 */
    public Wall() {
		type = Enum.WALL;
    }



/**
 * Reacts to the collision.
 *
 * @param s The Snake's reference that collided with the Wall.
 */  
    public void reactToCollision(Snake s) {
		s.collideWithWall(); //Callback to the colliding Snake
    }



/**
 * Returns the type of IContent
 */
	public int getType(){
		return type;
	}



/**
 * Returns id.
 */
	public int getID(){
		return 0;
	}



}
